using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddAuthorization();
        }

        #endregion
        #region ϱ - Configure(app, logger)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="logger">α ϱ</param>
        public void Configure(IApplicationBuilder app, ILogger<Startup> logger)
        {
            int count = 0;

            // ζ ̵ 1
            app.Use
            (
                next => async context =>
                {
                    using(new TimeHelper(logger, $"TIME {++count}"))
                    {
                        await next(context);
                    }
                }
            );

            app.UseRouting();

            // ζ ̵ 2
            app.Use
            (
                next => async context =>
                {
                    using(new TimeHelper(logger, $"TIME {++count}"))
                    {
                        await next(context);
                    }
                }
            );

            app.UseAuthorization();

            // ζ ̵ 3
            app.Use
            (
                next => async context =>
                {
                    using(new TimeHelper(logger, $"TIME {++count}"))
                    {
                        await next(context);
                    }
                }
            );

            app.UseEndpoints
            (
                endpoints =>
                {
                    endpoints.MapGet
                    (
                        "/",
                        async context =>
                        {
                            await context.Response.WriteAsync("Timing test.");
                        }
                    );
                }
            );
        }

        #endregion
    }
}