﻿using Microsoft.Extensions.Logging;
using System;
using System.Diagnostics;

namespace TestProject
{
    /// <summary>
    /// 시간 헬퍼
    /// </summary>
    public sealed class TimeHelper : IDisposable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 로그 기록기
        /// </summary>
        private ILogger<Startup> logger;

        /// <summary>
        /// 메시지
        /// </summary>
        private string message;

        /// <summary>
        /// 스톱워치
        /// </summary>
        private Stopwatch stopwatch;

        /// <summary>
        /// 리소스 해제 여부
        /// </summary>
        private bool disposed = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TimeHelper(logger, message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="logger">로그 기록기</param>
        /// <param name="message">메시지</param>
        public TimeHelper(ILogger<Startup> logger, string message)
        {
            this.logger    = logger;
            this.message   = message;
            this.stopwatch = Stopwatch.StartNew();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 리소스 해제하기 - Dispose()

        /// <summary>
        /// 리소스 해제하기
        /// </summary>
        public void Dispose()
        {
            if(!this.disposed)
            {
                this.logger.LogInformation($"{message } : {stopwatch.ElapsedMilliseconds}ms");

                this.disposed = true;
            }
        }

        #endregion
    }
}